# NOTE: Derived from ./blib/lib/Tk/MainWindow.pm.  Changes made here will be lost.
package MainWindow;

sub CmdLine
{
 my $top = shift;
 my $state = $top->state;

 *opt_fg = \$opt_foreground; 
 *opt_bg = \$opt_background; 
 *opt_fn = \$opt_font; 
 *opt_motif = \$Tk::strictMotif;

 my $result = GetOptions('iconposition=s',
                         'geometry=s',
                         'title=s',
                         'fg=s','foreground=s',
                         'bg=s','background=s',
                         'fn=s','font=s',
                         'iconic!','motif!');

 $top->title($opt_title) if (defined $opt_title);
 my (@colours) = ();
 push(@colours,foreground => $opt_foreground)if (defined $opt_foreground);
 $opt_background = '#d9d9d9' if (@colours && !defined($opt_background));
 push(@colours,background => $opt_background)if (defined $opt_background);
 $top->setPalette(@colours) if (@colours);

 $top->optionAdd('*font' => $opt_font)  if (defined $opt_font);

 if (defined $opt_iconposition)
  {
   my $icon = $top->iconwindow;
   my ($x,$y) = split(',',$opt_iconposition); 
   $top->iconposition($x,$y);
  }

 if (defined $opt_geometry)
  {
   $top->geometry($opt_geometry);
   $top->positionfrom('user');
   $top->sizefrom('user'); 
  }

 $top->protocol(WM_SAVE_YOURSELF => ['SaveYourself',$top]);
 $top->command([$0,@ARGV]);
 if (defined $opt_iconic && $opt_iconic)
  {
   $top->iconify unless ($state eq 'iconic');
  }
 else
  {
   $top->deiconify unless ($state eq 'normal');
  }
 return $top;
}

1;
