# NOTE: Derived from .././blib/lib/Tk/Scale.pm.  Changes made here will be lost.
package Tk::Scale;

sub ClassInit
{
 my ($class,$mw) = @_;
 $mw->bind($class,"<Enter>",
	     sub
	     {
	      my $w = shift;
	      my $Ev = $w->XEvent;
	      if ($Tk::strictMotif)
	       {
		$Tk::activeBg = $w->cget("-activebackground");
		$w->configure("-activebackground",$w->cget("-background"))
	       }
	      Activate($w,$Ev->x,$Ev->y)
	     }
	    )
 ;
 $mw->bind($class,"<Motion>",['Activate',Ev('x'),Ev('y')]);
 $mw->bind($class,"<Leave>",
	     sub
	     {
	      my $w = shift;
	      my $Ev = $w->XEvent;
	      if ($Tk::strictMotif)
	       {
		$w->configure("-activebackground",$Tk::activeBg)
	       }
	      if ($w->cget("-state") eq "active")
	       {
		$w->configure("-state","normal")
	       }
	     }
	    )
 ;
 $mw->bind($class,"<1>",['ButtonDown',Ev('x'),Ev('y')]);
 $mw->bind($class,"<B1-Motion>",['Drag',Ev('x'),Ev('y')]);
 $mw->bind($class,"<B1-Leave>",'NoOp');
 $mw->bind($class,"<B1-Enter>",'NoOp');
 $mw->bind($class,"<ButtonRelease-1>",
	     sub
	     {
	      my $w = shift;
	      my $Ev = $w->XEvent;
	      $w->CancelRepeat();
	      EndDrag($w);
	      Activate($w,$Ev->x,$Ev->y)
	     }
	    )
 ;
 $mw->bind($class,"<2>",['ButtonDown',Ev('x'),Ev('y')]);
 $mw->bind($class,"<B2-Motion>",['Drag',Ev('x'),Ev('y')]);
 $mw->bind($class,"<B2-Leave>",'NoOp');
 $mw->bind($class,"<B2-Enter>",'NoOp');
 $mw->bind($class,"<ButtonRelease-2>",
	     sub
	     {
	      my $w = shift;
	      my $Ev = $w->XEvent;
	      $w->CancelRepeat();
	      EndDrag($w);
	      Activate($w,$Ev->x,$Ev->y)
	     }
	    )
 ;
 $mw->bind($class,"<Control-1>",['ControlPress',Ev('x'),Ev('y')]);
 $mw->bind($class,"<Up>",['Increment',"up","little","noRepeat"]);
 $mw->bind($class,"<Down>",['Increment',"down","little","noRepeat"]);
 $mw->bind($class,"<Left>",['Increment',"up","little","noRepeat"]);
 $mw->bind($class,"<Right>",['Increment',"down","little","noRepeat"]);
 $mw->bind($class,"<Control-Up>",['Increment',"up","big","noRepeat"]);
 $mw->bind($class,"<Control-Down>",['Increment',"down","big","noRepeat"]);
 $mw->bind($class,"<Control-Left>",['Increment',"up","big","noRepeat"]);
 $mw->bind($class,"<Control-Right>",['Increment',"down","big","noRepeat"]);
 $mw->bind($class,"<Home>",["set",Ev("cget","-from")]);
 $mw->bind($class,"<End>",["set",Ev("cget","-to")]);
 return $class;
}
# Activate --
# This procedure is invoked to check a given x-y position in the
# scale and activate the slider if the x-y position falls within
# the slider.
#
# Arguments:
# w - The scale widget.
# x, y - Mouse coordinates.
1;
